<template>
  <v-row justify="center">
    <v-dialog
      v-model="dialog"
      width="1000px"
    >
      <template v-slot:activator="{ on, attrs }">
        <v-btn
        raised small color="primary" dark
        v-bind="attrs"
        v-on="on"
        >
        <v-icon left>mdi-microscope</v-icon>
        résultat
        </v-btn>
      </template>
      <v-card>
        <v-card-title>
          <span class="headline">RESULTATS D'ANALYSE MEDICALES</span>
        </v-card-title>

        <v-card-text>
          <v-btn
            color="green darken-1"
            text
            @click="download"
          >
          <v-icon left>mdi-file-pdf</v-icon>
            Exporter en pdf
          </v-btn>
          <v-spacer></v-spacer>
            <table class="table" id="my-table">
                <thead>
                    <tr>
                    <th scope="col">EXAMENS</th>
                    <th scope="col">RESULTATS</th>
                    <th scope="col">NORMES</th>
                    </tr>
                </thead>
                <tbody>
                    <tr v-for="testResultat in demand.test" :key="testResultat.id">
                        <th scope="row" >{{testResultat.exam.name}}</th>
                        <td><span v-if="testResultat.resultat_id">{{testResultat.resultat.unite?testResultat.resultat.value+' '+testResultat.resultat.unite:testResultat.resultat.value}}</span></td>
                        <td><span v-if="testResultat.resultat_id">{{testResultat.exam.norme}}</span></td>
                    </tr>
                </tbody>
                </table>
                
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn
            color="green darken-1"
            text
            @click="dialog = false"
          >
            Fermer
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
</template>

<script>

import { mapGetters } from 'vuex'
import jsPDF from 'jspdf'
import autoTable from 'jspdf-autotable'

  export default {
    props: {
      demand: Object,
    },
    data () {
      return {
        dialog: false,
      }
    },

    computed: {
       ...mapGetters({initialized:'examens/initialized', exam_types:"params/_exam_types", result_types:"params/_result_types", insurances:"params/_insurances", moreExists:'examens/moreExists',next_page_url:"examens/next_page_url",total:"examens/total"
                           ,current_page:"examens/current_page",items:"examens/_items",loading:"examens/loading",loaded:"examens/loaded",tests:"examens/_tests"}),
    },

    created(){
      this.$store.dispatch('examens/init')
    //   this.$store.dispatch('examens/getTest', this.demand.id)
       this.$store.dispatch('examens/getTest', 1)
  },
  
  methods: {
    download(){
        const doc = new jsPDF()
        doc.setFontSize(10).setFont("Times").text("MINISTERE DE LA SANTE", 10, 12);
        // doc.addImage('https://drive.google.com/file/d/1QQoGz2_7KFeO5Liyr-xvaGznq4sNp6_f/preview','JPEG', 85, -10);
        // doc.addImage('https://res-3.cloudinary.com/crunchbase-production/image/upload/c_lpad,f_auto,q_auto:eco/uncux0rq4bt7c6qcb7fd', "JPEG", 85, -10);
        doc.setFontSize(10).setFont("Times").text("REPUBLIQUE GABONAISE", 145, 12);
        doc.setFontSize(10).setFont("Times").text("LABORATOIRE D'ANALYSES MEDICALES", 10, 17);
        doc.setFontSize(10).setFont("Times").text("Union - Travail - Justice", 148, 17);
        doc.setFontSize(10).setFont("Times").text("BIOCLIN", 10, 22);
        doc.setFontSize(10).setFont("Times").text("TEL: (+241)66589926/ 74302904/ 66367633", 10, 27);
        doc.setFontSize(10).setFont("Times").text("Date: Libreville, le", 145, 27);
        doc.setFontSize(10).setFont("Times").text(""+moment(this.demand.created_at).format('DD/MM/YYYY'), 172, 27);
        doc.setFontSize(10).setFont("Times").text("EMAIL: bioclinlabo@yahoo.com", 10, 32);
        doc.setFontSize(10).setFont("Times").text("BP: 11703 Montagne Sainte", 10, 37);
        doc.setFontSize(12).setFont("Times").text("RESULTATS D'ANALYSES MEDICALES", 70, 47);
        doc.setFontSize(12).setFont("Times").text("NOM ET PRENOMS DU PATIENT :", 20, 57);
        doc.setFontSize(12).setFont("Times").text(""+this.demand.patient.fullName.toUpperCase(), 90, 57);

        autoTable(doc, { 
          html: '#my-table',
          margin:{ top:60, bottom: 60 },
          headStyles:{
            fillColor: '#58AFF0',
            textColor:"#ffffff",
            halign: 'center'
          },
          theme: 'grid',
        })

        doc.setFontSize(11).setFont("Times").text("LE TECHNICIEN", 90, doc.internal.pageSize.height - 15)

        // doc.setFontSize(12).text("LE TEHNICIEN", 70,);

        doc.save("Résultat des examens de la demande "+this.demand.id+" du patient "+this.demand.patient.fullName+' le '+moment(this.demand.created_at).format('DD/MM/YYYY à HH:M:SS')+".pdf")
    }
  }
}
  
</script>